<template>
  <div class="app-container">
    <el-card>
      <div>
         <el-button type="primary" icon="el-icon-plus" @click="handleCreate"
        >新增客户</el-button
      >
      <el-input
              v-model="listQuery.search"
              placeholder="客户名称"
              style="width: 300px"
              class="filter-item"
              @keyup.enter.native="handleFilter"
            />
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-search"
              @click="handleFilter"
              >搜索</el-button
            >
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-refresh-left"
              @click="resetFilter"
              >重置</el-button
            >
    </div>
   
    </el-card>
    <el-card style="margin-top: 2px">
      <el-table
        v-loading="listLoading"
        :data="customerList.results"
        border
        fit
        stripe
        highlight-current-row
       height="100"
        v-el-height-adaptive-table="{bottomOffset: 50}"
      >
        <el-table-column type="index" width="50" />
        <el-table-column label="客户名称" width="200" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.name }}</template>
        </el-table-column>
       
        <el-table-column label="详细地址" width="200" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.address }}</template>
        </el-table-column>
         <el-table-column label="联系人" width="130" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.contact }}</template>
        </el-table-column>
         <el-table-column label="联系电话" width="130" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.contact_phone }}</template>
        </el-table-column>
       <el-table-column label="描述" width="200" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.description }}</template>
        </el-table-column>
  <el-table-column label="创建时间" width="160" >
          <template slot-scope="scope">{{ scope.row.create_time }}</template>
        </el-table-column>
        <el-table-column
          align="center"
          label="操作"
         
        >
          <template slot-scope="scope">
           
            <el-link
              v-if="checkPermission(['warehouse_update'])"
              @click="handleEdit(scope)"
              >编辑</el-link
            >
            <el-link
              v-if="checkPermission(['warehouse_delete'])"
              type="danger"
              @click="handleDelete(scope)"
              >删除</el-link
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="customerList.count > 0"
        :total="customerList.count"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.page_size"
        @pagination="getList"
      />
    </el-card>
    <el-dialog
      :visible.sync="dialogVisible"
      :close-on-click-modal="false"
      :title="dialogType === 'edit' ? '编辑客户' : '新增客户'"
    >
      <el-form
        ref="Form"
        :model="customer"
        label-width="80px"
        label-position="right"
        :rules="rule1"
      >
        <el-form-item label="客户名称" prop="name">
          <el-input v-model="customer.name" placeholder="客户名称" />
        </el-form-item>
        <el-form-item label="客户地址" prop="address">
          <el-input v-model="customer.address" placeholder="客户地址" />
        </el-form-item>
         <el-form-item label="联系人" prop="contact">
          <el-input v-model="customer.contact" placeholder="联系人" />
        </el-form-item>
         <el-form-item label="联系电话" prop="contact_phone">
          <el-input v-model="customer.contact_phone" placeholder="联系电话" />
        </el-form-item>
         <el-form-item label="描述" prop="description">
          <el-input v-model="customer.description" placeholder="描述" />
        </el-form-item>
        
      </el-form>
      <div style="text-align: right">
        <el-button type="danger" @click="dialogVisible = false">取消</el-button>
        <el-button type="primary" @click="confirm('Form')">确认</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getCustomerList, createCustomer,updateCustomer,deleteCustomer } from "@/api/sam";
import checkPermission from "@/utils/permission";


import { genTree } from "@/utils";
import Pagination from "@/components/Pagination"; // secondary package based on el-pagination
const defaultecustomer = {
};
export default {
  components: { Pagination },
  data() {
    return {
      customer: defaultecustomer,
     customerList: {
        count: 0,
      },
       listQuery: {
        page: 1,
        page_size: 20,
      },
      listLoading: true,
      dialogVisible: false,
      dialogType: "new",
      rule1: {
        name: [{ required: true, message: "请输入", trigger: "blur" }],
      },
    };
  },
  computed: {},
  watch: {},
  created() {
    this.getList();
  },
  methods: {
    checkPermission,
    //设备列表
    getList() {
      this.listLoading = true;
      getCustomerList(this.listQuery).then((response) => {
        if (response.data) {
          this.customerList = response.data;
        }
        this.listLoading = false;
      });
    },
   
    
    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    resetFilter() {
      this.listQuery = {
        page: 1,
        page_size: 20,
      }
      this.getList();
    },
    handleCreate() {
      this.customer = Object.assign({}, defaultecustomer);
      this.dialogType = "new";
      this.dialogVisible = true;
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
   
    handleEdit(scope) {
      this.customer = Object.assign({}, scope.row); // copy obj
      this.dialogType = "edit";
      this.dialogVisible = true;
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
    handleDelete(scope) {
      this.$confirm("确认删除?", "警告", {
        confirmButtonText: "确认",
        cancelButtonText: "取消",
        type: "error",
      })
        .then(async () => {
          await deleteCustomer(scope.row.id);
          this.getList();
          this.$message.success("成功");
        })
        .catch((err) => {
          console.error(err);
        });
    },
   
    async confirm(form) {
      this.$refs[form].validate((valid) => {
        if (valid) {
          const isEdit = this.dialogType === "edit";
          if (isEdit) {
            updateCustomer(this.customer.id, this.customer).then((res) => {
              if (res.code >= 200) {
                this.getList();
                this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          } else {
            createCustomer(this.customer).then((res) => {
              if (res.code >= 200) {
                this.getList();
                 this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          }
        } else {
          return false;
        }
      });
    },
  },
};
</script>
